import java.awt.*;
import javax.swing.*;
import WebFlow.submitJob2.*;

public class runJob implements Runnable {

private String command;
private boolean debug;
private JTextArea resultText;
private JScrollPane sp;
private JViewport vp;
private Point p;
private Dimension d;
private int x,y;

  public runJob(String command, JTextArea resultText, JScrollPane sp,
                 boolean debug) {
    this.command = command;
    this.resultText = resultText;
    this.sp = sp;
    this.debug = debug;

    vp = sp.getViewport();
    p = vp.getViewPosition();
    d = vp.getExtentSize(); 
    x=p.x;
  }

  public void run(){
System.out.println("Run Started............") ;
System.out.println("debug is " + debug) ;
     Connection.submit.submitLocally(command);
     if(debug) System.out.println("run locally completed");
     String OLine="";
     resultText.setText(OLine);
     int curLine=0; 
     if(debug) System.out.println("start reading...");
     while(!OLine.equals("theEnd")) {
       OLine=Connection.submit.getOLine(curLine);
       if(OLine.equals("wait")) {
          if(debug) System.out.println("waiting...");
          waitFor(10);
       }
       else {
	  if(debug) System.out.println(curLine+" "+OLine);
          resultText.append(OLine+"\n");

          /* make the scrollbar move down automatically */
          y=resultText.getHeight()-d.height;
          vp.setViewPosition(new Point(x,y)); 

          Connection.submit.setLineRead(curLine);
          curLine++;
          if(curLine==20) curLine=0;
       }  
     }      
  }

  public synchronized void waitFor(long howLong){
     try {
        wait(howLong);
     } catch (Exception e) { System.out.println(e);}
   }

}
