import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;
import java.awt.event.*;
import WebFlow.*;
import WebFlow.event.*;
import WebFlow.xml.*;
import org.omg.CORBA.*;
import javax.swing.*;
import java.io.*;
import java.net.*;
import java.util.*;

public class AADframe extends JInternalFrame {

CardLayout cl;
JPanel cardPanel, ApplListCard, HostListCard, newSwitch, newHost;
JPanel newCommand, CommandCard, CommandFields, newArgument, newApplication;
JPanel newInput, newOutput;
JTextField newApplName, newHostName, CommandTF, newCommandName;
JTextArea newApplDescription, newHostDescription;
ActionListener blistener;
String selectedServer,selectedSwitch,selectedArgument,selectedInput;
String selectedOutput;
int currentIndex;
desktop d;
String application,ApplHost,commandLine;
ORB orb;
String IorURL;
WebFlowContext master;
XmlServer parser;
String xmlFile;
Vector a,h,arguments,switches,infiles,outfiles;
JList aList,hList,argList,swtList,inpList,outList;
JLabel aListLabel,hListLabel,CommandLabel;
JLabel newSwitchLabelA, newSwitchLabelH, newSwitchLabelC;
JLabel newArgumentLabelA, newArgumentLabelH, newArgumentLabelC;
JLabel newInputLabelA, newInputLabelH, newInputLabelC;
JLabel newOutputLabelA, newOutputLabelH, newOutputLabelC;
String newSwitch_m,newSwitch_type,newSwitch_separator,newSwitch_ms;
String newSwitch_name,newSwitch_value;
String newArgument_m,newArgument_type;
String newArgument_name,newArgument_value;
JTextField newSwitch_nameTF, newSwitch_valueTF;
JTextField newArgument_nameTF;
JTextField newInput_nameTF, newInput_pathTF;
JTextField newOutput_nameTF, newOutput_pathTF;
JComboBox cbs_ms,cbs_separator,cbs_type,cbs_m;
JComboBox cba_type,cba_m;
String oldInFile, oldOutFile;

  public AADframe(desktop d) {
  super("AAD manager", true, true, true, true);

  this.d = d;
  IorURL = d.IORfileURL;
  
  this.selectedServer = d.selectedServer;
  //  xmlFile = "C:\\Jigsaw\\Jigsaw\\Jigsaw\\WWW\\DESCRIPTORS\\APPLICATION\\TestAAD.xml";
  xmlFile = d.AADxml;
  connect();

  blistener = new ActionListener() {
    public void actionPerformed(ActionEvent e) {
     String button = e.getActionCommand();
    if(button.equals("add new application")) showNewApplicationPanel();
    if(button.equals("delete application")) deleteApplication();
    if(button.equals("hosts")) listHosts();
    if(button.equals("List Hosts")) listHosts();
    if(button.equals("Add Application")) addApplication();
    if(button.equals("List Applications")) listApplications();
    if(button.equals("add new host")) showNewHostPanel();
    if(button.equals("delete host")) deleteHost();
    if(button.equals("show details")) showDetails();
    if(button.equals("Add Host")) addHost();
    if(button.equals("Set Command")) setCommand();
    if(button.equals("Add Argument")) showNewArgumentPanel();
    if(button.equals("Add Switch")) showNewSwitchPanel();
    if(button.equals("Add Input File")) showNewInputFilePanel();
    if(button.equals("Add Output File")) showNewOutputFilePanel();
    if(button.equals("Edit Argument")) showEditArgumentPanel();
    if(button.equals("Edit Switch")) showEditSwitchPanel();
    if(button.equals("Edit Input File")) showEditInputFilePanel();
    if(button.equals("Edit Output File")) showEditOutputFilePanel();
    if(button.equals("Back")) showDetails();
    if(button.equals("Cancel")) showDetails();
    if(button.equals("Reset Switch")) resetSwitch();
    if(button.equals("Next Switch")) nextSwitch();
    if(button.equals("Delete Switch")) deleteSwitch();
    if(button.equals("Accept Switch")) acceptSwitch();
    if(button.equals("Delete Installation")) deleteInstallation();
    if(button.equals("Reset Argument")) resetArgument();
    if(button.equals("Next Argument")) nextArgument();
    if(button.equals("Delete Argument")) deleteArgument();
    if(button.equals("Accept Argument")) acceptArgument();
    if(button.equals("Reset Input")) resetInput();
    if(button.equals("Next Input")) nextInput();
    if(button.equals("Delete Input")) deleteInput();
    if(button.equals("Accept Input")) acceptInput();
    if(button.equals("Reset Output")) resetOutput();
    if(button.equals("Next Output")) nextOutput();
    if(button.equals("Delete Output")) deleteOutput();
    if(button.equals("Accept Output")) acceptOutput();
    }
  };

  JPanel bck = new JPanel();
  getContentPane().add(bck);

  bck.setLayout(new BorderLayout());
  JPanel titlePanel = new JPanel();
  titlePanel.setLayout(new GridLayout(3,1));
  titlePanel.add(new JLabel(" "));
  titlePanel.add(new JLabel("Abstract Application Descriptor", JLabel.CENTER));
  titlePanel.add(new JLabel(" "));
  bck.add(titlePanel,BorderLayout.NORTH);

  JPanel AAD = new JPanel();
  AAD.setLayout(new BorderLayout());
  
  JPanel buttons = new JPanel();
  buttons.setLayout(new GridLayout(1,5));
  
  JButton newButton = new JButton("new");
  JButton findButton = new JButton("find");
  JButton viewButton = new JButton("view");
  JButton modifyButton = new JButton("modify");
  JButton commitButton = new JButton("commit");

  ActionListener bl = new ActionListener() {
        public void actionPerformed(ActionEvent ev) {
          showCard(ev.getActionCommand());
        }
  };


   newButton.addActionListener(bl); 
   findButton.addActionListener(bl); 
   viewButton.addActionListener(bl); 
   modifyButton.addActionListener(bl); 
   commitButton.addActionListener(bl); 
 
  buttons.add(newButton);
  buttons.add(findButton);
  buttons.add(viewButton);
  buttons.add(modifyButton);
  buttons.add(commitButton);
  AAD.add(buttons,BorderLayout.NORTH);

  cardPanel = new JPanel();
  cl = new CardLayout();
  cardPanel.setLayout(cl);

  ApplListCard = new JPanel();
  initializeApplListCard();

  cardPanel.add("ApplList",ApplListCard); 
  cl.show(cardPanel,"ApplList");

  HostListCard = new JPanel();
  initializeHostListCard();
  cardPanel.add("HostList",HostListCard); 

  CommandCard = new JPanel();
  initializeCommandCard();
  cardPanel.add("Command",CommandCard); 

  newArgument = new JPanel();
  initializeNewArgumentCard();
  cardPanel.add("newArgument",newArgument);
  
  newSwitch = new JPanel();
  initializeNewSwitchCard();
  cardPanel.add("newSwitch",newSwitch);

  newInput = new JPanel();
  initializeNewInputCard();
  cardPanel.add("newInput",newInput);

  newOutput = new JPanel();
  initializeNewOutputCard();
  cardPanel.add("newOutput",newOutput);

  JPanel modifyPanel = new JPanel();
  cardPanel.add("modify",modifyPanel);

  JPanel viewPanel = new JPanel();
  cardPanel.add("view",viewPanel);

  JPanel commitPanel = new JPanel();
  cardPanel.add("commit",commitPanel);

  newApplication = new JPanel();
  newApplication.setLayout(new BorderLayout());
  JPanel newApplicationNamePanel = new JPanel(); 
  newApplicationNamePanel.add(new JLabel("Application name: "));
  newApplName = new JTextField(20);
  newApplicationNamePanel.add(newApplName);
  newApplication.add(newApplicationNamePanel,BorderLayout.NORTH);
  newApplDescription = new JTextArea(20,5);
  newApplication.add(newApplDescription, BorderLayout.CENTER);
  JPanel newApplicationNameButtons = new JPanel();
  newApplicationNameButtons.setLayout(new GridLayout(1,2));
  JButton newApplicationNameb1=new JButton("Add Application"); 
  JButton newApplicationNameb2=new JButton("Applications"); 
  newApplicationNameb1.addActionListener(blistener);
  newApplicationNameb2.addActionListener(blistener);
  newApplicationNameButtons.add(newApplicationNameb1);
  newApplicationNameButtons.add(newApplicationNameb2);
  newApplication.add(newApplicationNameButtons,BorderLayout.SOUTH);
  cardPanel.add("newApplication",newApplication);


  newHost = new JPanel();
  newHost.setLayout(new BorderLayout());
  JPanel newHostNamePanel = new JPanel(); 
  newHostNamePanel.add(new JLabel("Host name: "));
  newHostName = new JTextField(20);
  newHostNamePanel.add(newHostName);
  newHost.add(newHostNamePanel,BorderLayout.NORTH);
  newHostDescription = new JTextArea(20,5);
  newHost.add(newHostDescription, BorderLayout.CENTER);
  JPanel newHostNameButtons = new JPanel();
  newHostNameButtons.setLayout(new GridLayout(1,2));
  JButton newHostNameb1=new JButton("Add Host"); 
  JButton newHostNameb2=new JButton("hosts"); 
  newHostNameb1.addActionListener(blistener);
  newHostNameb2.addActionListener(blistener);
  newHostNameButtons.add(newHostNameb1);
  newHostNameButtons.add(newHostNameb2);
  newHost.add(newHostNameButtons,BorderLayout.SOUTH);
  cardPanel.add("newHost",newHost);

  newCommand = new JPanel();
  /*
  newCommand.setLayout(new BorderLayout());
  JPanel newCommandNamePanel = new JPanel(); 
  newCommandNamePanel.add(new JLabel("Command: "));
  newCommandName = new JTextField(20);
  newCommandNamePanel.add(newCommandName);
  newCommand.add(newCommandNamePanel,BorderLayout.NORTH);
  JTextArea newCommandDescription = new JTextArea(20,5);
  newCommand.add(newCommandDescription, BorderLayout.CENTER);
  JPanel newCommandNameButtons = new JPanel();
  newCommandNameButtons.setLayout(new GridLayout(1,2));
  JButton newCommandNameb1=new JButton("Set Command"); 
  JButton newCommandNameb2=new JButton("Back"); 
  newCommandNameb1.addActionListener(blistener);
  newCommandNameb2.addActionListener(blistener);
  newCommandNameButtons.add(newCommandNameb1);
  newCommandNameButtons.add(newCommandNameb2);
  newCommand.add(newCommandNameButtons,BorderLayout.SOUTH);
  */
  cardPanel.add("newCommand",newCommand);



  AAD.add(cardPanel,BorderLayout.CENTER);
  bck.add(AAD,BorderLayout.CENTER);
  }



  public void showCard(String what){
    cl.show(cardPanel,what);
  }


  public void setSelectedHost(String h) {
     ApplHost = h;
  } 

  public void setApplicationName(String h) {
     application = h;
  } 

  public void connect() {
    initializeORB();
    master = getMasterServer();
    if(master==null) {
      System.out.println("Cannot connect to the master server");
    }
    else {
	/* add XMLserver module */

        org.omg.CORBA.Object oxml = master.addNewModule("XmlServer");
        parser = XmlServerHelper.narrow(oxml);
        parser.test();

    }
  }


  public void initializeORB() { 
   Properties props = System.getProperties();
   props.put("org.omg.CORBA.ORBClass", "com.ooc.CORBA.ORB");
   props.put("org.omg.CORBA.ORBSingletonClass", "com.ooc.CORBA.ORBSingleton");
   System.setProperties(props);
   String[] args = new String[1];
   args[0]=IorURL;
   orb = ORB.init(args, props);
  }

  public WebFlowContext getMasterServer(){
    WebFlowContext ws = null;
    try {
      String masterIOR = getIORFromURL(IorURL);
      org.omg.CORBA.Object o = orb.string_to_object(masterIOR);
      
      ws = WebFlowContextHelper.narrow(o);
    }
    catch (Exception e) {System.out.println("getMasterServer: "+e);}
    return ws;
  }

  public String getIORFromURL(String urlString){
    String masterServerIOR="";
    String thisLine=null;
      try {
        URL u = new URL(urlString);
        try {
          DataInputStream theHTML = new DataInputStream(u.openStream());
          try {
            while ((thisLine = theHTML.readLine()) != null) {
		  masterServerIOR += thisLine;
            } 
          } 
          catch (Exception e) {
            System.out.println("getIORfromURL:"+e);
          }
        } 
        catch (Exception e) {
          System.out.println("getIORfromURL:"+e);
        }

      } 
      catch (MalformedURLException e) {
        System.out.println("getIORfromURL:"+urlString + " is not a parseable URL");
        System.out.println("getIORfromURL:"+e);
      }
    return masterServerIOR;
  }

  public void initializeApplListCard() {
    String title = xmlFile+" defines ";

    if(!parser.instantiateParser(xmlFile)) {
      if(parser.newAAD(xmlFile,d.AADdtd))
         parser.SaveAsXml(xmlFile);
      else  
         System.out.println("cannot create "+xmlFile);
    }
    if(parser.instantiateParser(xmlFile)) {
       String[] Apps = parser.getApplications();
       int n=Apps.length;
       title += n+" application(s)";
       a = new Vector();
       if(n>0) {
         for(int i=0;i<n;i++) {
           a.addElement(Apps[i]);
	 }
       }
    }


   ApplListCard.setLayout(new BorderLayout());
   aListLabel = new JLabel(title);
   aList = new JList(a); 
   aList.addListSelectionListener(new ListSelectionListener() {
     public void valueChanged(ListSelectionEvent e) {
       if(e.getValueIsAdjusting()==false) return;
       System.out.println(e.getFirstIndex());
       selectApplication();
     }
   });

   JPanel aListButtons = new JPanel();
   aListButtons.setLayout(new GridLayout(1,3));
   JButton aListb1=new JButton("add new application");
   JButton aListb2=new JButton("delete application");
   JButton aListb3=new JButton("hosts");
   aListButtons.add(aListb1);
   aListButtons.add(aListb2);
   aListButtons.add(aListb3);
   aListb1.addActionListener(blistener);
   aListb2.addActionListener(blistener);
   aListb3.addActionListener(blistener);

   ApplListCard.add(aListLabel,BorderLayout.NORTH);
   ApplListCard.add(aList,BorderLayout.CENTER);
   ApplListCard.add(aListButtons,BorderLayout.SOUTH);
  }

  public void listApplications() {
   a.removeAllElements();
   String title = xmlFile+" defines ";
   if(parser.instantiateParser(xmlFile)) {
     String[] Apps = parser.getApplications();
     int n=Apps.length;
     title += n+" application(s)";
     if(n>0) {
       for(int i=0;i<n;i++) {
         a.addElement(Apps[i]);
	}
     }
    aListLabel.setText(title);
    aList.setListData(a);
    cl.show(cardPanel,"ApplList");
   }
   else System.out.println("update application list failed");
  }

  public void selectApplication() {
   int i = aList.getSelectedIndex();
   application=(String)a.elementAt(i);
  } 

  public void addApplication() {
   String newName = newApplName.getText();
     if(parser.instantiateParser(xmlFile)) {
       parser.addApplication(newName,false);
       parser.SaveAsXml(xmlFile);
     }     
     else {
       System.out.println("adding application "+newName+" failed");
     }
    listApplications();  
  }


  public void addHost() {
   String newHost = newHostName.getText();
     if(parser.instantiateParser(xmlFile)) {
       parser.addApplicationHost(application,newHost);
       parser.changeInstalledStatus(application,newHost,"Yes");
       parser.SaveAsXml(xmlFile);
     }     
     else {
       System.out.println("adding application "+newHost+" failed");
     }
    listHosts();  
  }

  public void listHosts() {
    h.removeAllElements();
    String title = application+ " is installed on ";   
    if(parser.instantiateParser(xmlFile)) {
       String[] Hosts = parser.getInstalledHosts(application);
       int n=Hosts.length;
       title += n+" host(s)";
       if(h==null) h = new Vector();
       else h.removeAllElements();
       if(n>0) {
         for(int i=0;i<n;i++) {
           h.addElement(Hosts[i]);
	 }
       }
    }

   hListLabel.setText(title);
   hList.setListData(h); 
   cl.show(cardPanel,"HostList");
  }


  public void addNewApplication() {
   String newA = newApplName.getText();
   if(parser.instantiateParser(xmlFile)) {
    parser.addApplication(newA,false); 
    parser.SaveAsXml(xmlFile);
   } 
  }

  public void showNewHostPanel() {
   cl.show(cardPanel,"newHost");
  }

  public void showNewApplicationPanel() {
   cl.show(cardPanel,"newApplication");
  }

  public void deleteApplication() {
    if(parser.instantiateParser(xmlFile)) {
     parser.deleteApplication(application);
     parser.SaveAsXml(xmlFile);
    }
    listApplications(); 
  }

  public void initializeHostListCard() {
    h = new Vector();
    h.addElement("whatever");
    HostListCard.setLayout(new BorderLayout());
    hListLabel = new JLabel("initialization");
    hList = new JList(h); 
    hList.addListSelectionListener(new ListSelectionListener() {
     public void valueChanged(ListSelectionEvent e) {
       if(e.getValueIsAdjusting()==false) return;
       System.out.println(e.getFirstIndex());
       selectHost();
     }
   });

   JPanel hListButtons = new JPanel();
   hListButtons.setLayout(new GridLayout(1,4));
   JButton hListb1=new JButton("add new host");
   JButton hListb2=new JButton("delete host");
   JButton hListb3=new JButton("show details");
   JButton hListb4=new JButton("List Applications");
   hListButtons.add(hListb1);
   hListButtons.add(hListb2);
   hListButtons.add(hListb3);
   hListButtons.add(hListb4);
   hListb1.addActionListener(blistener);
   hListb2.addActionListener(blistener);
   hListb3.addActionListener(blistener);
   hListb4.addActionListener(blistener);

   HostListCard.add(hListLabel,BorderLayout.NORTH);
   HostListCard.add(hList,BorderLayout.CENTER);
   HostListCard.add(hListButtons,BorderLayout.SOUTH);
  }


  public void selectHost() {
   currentIndex = hList.getSelectedIndex();
   ApplHost=(String)h.elementAt(currentIndex);
   System.out.println("selected host: "+ApplHost);
  }
  public void selectSwitch() {
   currentIndex = swtList.getSelectedIndex();
   selectedSwitch=(String)switches.elementAt(currentIndex);
  }
  public void selectInput() {
   currentIndex = inpList.getSelectedIndex();
   selectedInput=(String)infiles.elementAt(currentIndex);
  }
  public void selectOutput() {
   currentIndex = outList.getSelectedIndex();
   selectedOutput=(String)outfiles.elementAt(currentIndex);
  }
  public void selectArgument() {
   int currentIndex = argList.getSelectedIndex();
   selectedArgument=(String)arguments.elementAt(currentIndex);
  }

  public void deleteHost() {
   System.out.println("delete host: "+ApplHost);
   if(parser.instantiateParser(xmlFile)) {
     parser.deleteHost(application,ApplHost);
     parser.SaveAsXml(xmlFile);
   }
   else System.out.println("cannot delete host");
  }

  public void showDetails() { 

    CommandLabel.setText(application+": definition on "+ApplHost);

    CommandTF.setText("");
    arguments.removeAllElements();
    switches.removeAllElements();
    outfiles.removeAllElements();
    infiles.removeAllElements();

    if(parser.instantiateParser(xmlFile)) {
      if(parser.isApplicationInstalled(application,ApplHost)) {
       String Exec=parser.getExec(application, ApplHost);
       if(Exec != null) CommandTF.setText(Exec);  

       String[] ars=parser.getArguments(application,ApplHost);
       int nargs = ars.length;
       System.out.println("nargs="+nargs);
       if(nargs>0 && (!ars[0].equals("null"))) {
         for(int i=0; i<nargs; i++){
            arguments.addElement(ars[i]);
	 }
       }
       else {
          arguments.addElement("none"); 
       } 

       String[] sws=parser.getSwitches(application, ApplHost);
       int nswt = sws.length; 
       if(nswt>0 && (!sws[0].equals("null"))) {
         for(int i=0; i<nswt; i++){
            switches.addElement(sws[i]);
	 } 
       }
       else {
           switches.addElement("none");
       } 
       
       String[] inputs=parser.getIPFiles(application, ApplHost);
       int ninp = inputs.length; 
       if(ninp>0) {
         for(int i=0; i<ninp/2; i++){
	     if(inputs[i].length()>1) {
               infiles.addElement(inputs[i]+"/"+inputs[i+1]);
             }
             else {
               infiles.addElement(inputs[i+1]);
	     }
	 } 
       }
       else {
            infiles.addElement("none");
       }  

       String[] outputs=parser.getOPFiles(application, ApplHost);
       int noutp = outputs.length; 
       if(noutp>0) {
         for(int i=0; i<noutp/2; i++){
	     if(outputs[i].length()>1) {
               outfiles.addElement(outputs[i]+"/"+outputs[i+1]);
             }
             else {
	       outfiles.addElement(outputs[i+1]);
	     } 
	 } 
       } 
       else {
            outfiles.addElement("none");
       }
      }
      else {
         arguments.addElement("none");
         switches.addElement("none");    
         infiles.addElement("none");    
         outfiles.addElement("none");
      }    
       argList.setListData(arguments);
       swtList.setListData(switches);
       inpList.setListData(infiles);
       outList.setListData(outfiles);
    }
    else { System.out.println("cannot read "+xmlFile);}
    cl.show(cardPanel,"Command");
  }

  public void initializeCommandCard() {

    String str1 = "  Executable:";
    String str2 = "   Arguments:";
    String str3 = "    Switches:";
    String str4 = " Input Files:";
    String str5 = "Output Files:";  

    CommandCard.setLayout(new BorderLayout());
    CommandLabel = new JLabel("application parameters");
    CommandFields = new JPanel();

    arguments = new Vector();
    switches = new Vector();
    infiles = new Vector();
    outfiles = new Vector();

    CommandFields.setLayout(new GridLayout(5,1));

    JPanel p1 = new JPanel();
    p1.setLayout(new GridLayout(2,1));
    JLabel l1 = new JLabel(str1);
    l1.setFont(new Font("Courier", Font.BOLD, 12));
    l1.setForeground(Color.black);
    p1.add(l1,BorderLayout.WEST);
    CommandTF = new JTextField(30);
    p1.add(CommandTF);
    CommandFields.add(p1);

    JPanel p2 = new JPanel();
    p2.setLayout(new BorderLayout());
    JLabel l2 = new JLabel(str2);
    l2.setFont(new Font("Courier", Font.BOLD, 12));
    l2.setForeground(Color.black);
    p2.add(l2,BorderLayout.WEST);
    argList = new JList(arguments);
    argList.addListSelectionListener(new ListSelectionListener() {
     public void valueChanged(ListSelectionEvent e) {
       if(e.getValueIsAdjusting()==false) return;
       System.out.println(e.getFirstIndex());
       selectArgument();
     }
   });
    JScrollPane sp2 = new JScrollPane(argList);
    p2.add(sp2,BorderLayout.CENTER);
    CommandFields.add(p2);

    JPanel p3 = new JPanel();
    p3.setLayout(new BorderLayout());
    JLabel l3 = new JLabel(str3);
    l3.setFont(new Font("Courier", Font.BOLD, 12));
    l3.setForeground(Color.black);
    p3.add(l3,BorderLayout.WEST);
    swtList = new JList(switches);
    swtList.addListSelectionListener(new ListSelectionListener() {
     public void valueChanged(ListSelectionEvent e) {
       if(e.getValueIsAdjusting()==false) return;
       System.out.println(e.getFirstIndex());
       selectSwitch();
     }
   });
    JScrollPane sp3 = new JScrollPane(swtList);
    p3.add(sp3,BorderLayout.CENTER);
    CommandFields.add(p3);

    JPanel p4 = new JPanel();
    p4.setLayout(new BorderLayout());
    p4.add(new JLabel("input files :"),BorderLayout.WEST);
    JLabel l4 = new JLabel(str4);
    l4.setFont(new Font("Courier", Font.BOLD, 12));
    l4.setForeground(Color.black);
    p4.add(l4,BorderLayout.WEST);
    inpList = new JList(infiles);
    inpList.addListSelectionListener(new ListSelectionListener() {
     public void valueChanged(ListSelectionEvent e) {
       if(e.getValueIsAdjusting()==false) return;
       System.out.println(e.getFirstIndex());
       selectInput();
     }
   });
    JScrollPane sp4 = new JScrollPane(inpList);
    p4.add(sp4,BorderLayout.CENTER);
    CommandFields.add(p4);
    JPanel p5 = new JPanel();
    p5.setLayout(new BorderLayout());
    JLabel l5 = new JLabel(str5);
    l5.setFont(new Font("Courier", Font.BOLD, 12));
    l5.setForeground(Color.black);
    p5.add(l5,BorderLayout.WEST);
    outList = new JList(outfiles);
    outList.addListSelectionListener(new ListSelectionListener() {
     public void valueChanged(ListSelectionEvent e) {
       if(e.getValueIsAdjusting()==false) return;
       System.out.println(e.getFirstIndex());
       selectOutput();
     }
   });
    JScrollPane sp5 = new JScrollPane(outList);
    p5.add(sp5, BorderLayout.CENTER);
    CommandFields.add(p5);

   JPanel CommandButtons = new JPanel();
   CommandButtons.setLayout(new GridLayout(3,4));
   JButton Commandb1=new JButton("Set Command");
   JButton Commandb2=new JButton("Delete Installation");
   JButton Commandb3=new JButton("List Hosts");
   JButton Commandb4=new JButton("List Applications");
   JButton Commandb5=new JButton("Edit Argument");
   JButton Commandb6=new JButton("Edit Switch");
   JButton Commandb7=new JButton("Edit Input File");
   JButton Commandb8=new JButton("Edit Output File");
   JButton Commandb9=new JButton("Add Argument");
   JButton Commandb10=new JButton("Add Switch");
   JButton Commandb11=new JButton("Add Input File");
   JButton Commandb12=new JButton("Add Output File");
   CommandButtons.add(Commandb1);
   CommandButtons.add(Commandb2);
   CommandButtons.add(Commandb3);
   CommandButtons.add(Commandb4);
   CommandButtons.add(Commandb5);
   CommandButtons.add(Commandb6);
   CommandButtons.add(Commandb7);
   CommandButtons.add(Commandb8);
   CommandButtons.add(Commandb9);
   CommandButtons.add(Commandb10);
   CommandButtons.add(Commandb11);
   CommandButtons.add(Commandb12);
   Commandb1.addActionListener(blistener);
   Commandb2.addActionListener(blistener);
   Commandb3.addActionListener(blistener);
   Commandb4.addActionListener(blistener);
   Commandb5.addActionListener(blistener);
   Commandb6.addActionListener(blistener);
   Commandb7.addActionListener(blistener);
   Commandb8.addActionListener(blistener);
   Commandb9.addActionListener(blistener);
   Commandb10.addActionListener(blistener);
   Commandb11.addActionListener(blistener);
   Commandb12.addActionListener(blistener);

   CommandCard.add(CommandLabel,BorderLayout.NORTH);
   CommandCard.add(CommandFields,BorderLayout.CENTER);
   CommandCard.add(CommandButtons,BorderLayout.SOUTH);
  }

  public void showNewCommandPanel() {
   cl.show(cardPanel,"newCommand");
  }

  public void showNewArgumentPanel() {
     newArgumentLabelA.setText("application: "+application); 
     newArgumentLabelH.setText("host: "+ApplHost);  
     if(parser.instantiateParser(xmlFile)) {  
     commandLine=parser.getExec(application,ApplHost);
     }
     else commandLine="none";
     newArgumentLabelC.setText("executable: "+commandLine);
     cba_type.setSelectedItem("literal");
     cba_m.setSelectedItem("fixed");
     newArgument_nameTF.setText("");

     showCard("newArgument");
  }

  public void showEditArgumentPanel() {
     newArgumentLabelA.setText("application: "+application); 
     newArgumentLabelH.setText("host: "+ApplHost);  
     if(parser.instantiateParser(xmlFile)) {  
     commandLine=parser.getExec(application,ApplHost);
     newArgumentLabelC.setText("executable: "+commandLine); 
     }
     String thisArgument = (String)arguments.elementAt(currentIndex);
     System.out.println(thisArgument);
     StringTokenizer st = new StringTokenizer(thisArgument);
     newArgument_nameTF.setText(st.nextToken());
     while(st.hasMoreTokens()) {
      String nToken = st.nextToken();
      int tokenLength = nToken.length();

	 if(nToken.startsWith("[t")) {
         System.out.println(nToken.substring(2,tokenLength-1));
           cba_type.setSelectedItem(nToken.substring(2,tokenLength-1));
	 }
         else {
           System.out.println(nToken.substring(2,tokenLength-1));
           cba_m.setSelectedItem(nToken.substring(2,tokenLength-1));
	 }
     }
     showCard("newArgument");
  }

  public void showEditSwitchPanel() {
     newSwitchLabelA.setText("application: "+application); 
     newSwitchLabelH.setText("host: "+ApplHost);  
     if(parser.instantiateParser(xmlFile)) {  
     commandLine=parser.getExec(application,ApplHost);
     newSwitchLabelC.setText("executable: "+commandLine); 
     }
     String thisSwitch = (String)switches.elementAt(currentIndex);
     System.out.println(thisSwitch);
     StringTokenizer st = new StringTokenizer(thisSwitch);
     newSwitch_nameTF.setText(st.nextToken());
     while(st.hasMoreTokens()) {
      String nToken = st.nextToken();
      int tokenLength = nToken.length();
      if(nToken.startsWith("[ms")) {
        System.out.println(nToken.substring(3,tokenLength-1));
        cbs_ms.setSelectedItem(nToken.substring(3,tokenLength-1));
      }
      else {
	  if(nToken.startsWith("[s")) {
            System.out.println(nToken); 
            if(nToken.indexOf("equal")>-1) 
               cbs_separator.setSelectedItem("-switch=Value");
            else {
               if(nToken.indexOf("space")>-1) 
                 cbs_separator.setSelectedItem("-switch Value");
               else
                 cbs_separator.setSelectedItem("-switchValue");
	    }
	  }
          else {
	      if(nToken.startsWith("[v")){
               System.out.println(nToken.substring(2,tokenLength-1));
               newSwitch_valueTF.setText(nToken.substring(2,tokenLength-1));
	      }
	      else {
		  if(nToken.startsWith("[t")) {
                   System.out.println(nToken.substring(2,tokenLength-1));
                   cbs_type.setSelectedItem(nToken.substring(2,tokenLength-1));
		  }
                  else {
                    System.out.println(nToken.substring(2,tokenLength-1));
                    cbs_m.setSelectedItem(nToken.substring(2,tokenLength-1));
                   
		       }
	      }
	  }
      }
     }  
     showCard("newSwitch");    
  }


  public void showNewSwitchPanel() {
     newSwitchLabelA.setText("application: "+application); 
     newSwitchLabelH.setText("host: "+ApplHost);  
     if(parser.instantiateParser(xmlFile)) {  
     commandLine=parser.getExec(application,ApplHost);
     }
     else commandLine="none";
     newSwitchLabelC.setText("executable: "+commandLine);
     cbs_ms.setSelectedItem("fixed"); 
     cbs_separator.setSelectedItem("-switch Value");
     cbs_type.setSelectedItem("literal");
     cbs_m.setSelectedItem("fixed");
     newSwitch_valueTF.setText("");
     newSwitch_nameTF.setText("");

     showCard("newSwitch");
  }

    public void resetSwitch() {
     newSwitch_nameTF.setText("");  
     newSwitch_valueTF.setText("");
     cbs_ms.setSelectedItem("fixed"); 
     cbs_separator.setSelectedItem("-switch Value");
     cbs_type.setSelectedItem("literal");
     cbs_m.setSelectedItem("fixed");
   }

    public void resetArgument() {
     newArgument_nameTF.setText("");  
     cba_type.setSelectedItem("literal");
     cba_m.setSelectedItem("fixed");
    }

    public void resetInput() {
     newInput_pathTF.setText("");  
     newInput_nameTF.setText("");  
    }

    public void resetOutput() {
     newOutput_pathTF.setText("");  
     newOutput_nameTF.setText("");  
    }


    public void nextSwitch() {
      saveSwitch();
      resetSwitch();
    }

    public void nextArgument() {
      saveArgument();
      resetArgument();
    }

    public void nextInput() {
      saveInput();
      resetInput();
    }

    public void nextOutput() {
      saveOutput();
      resetOutput();
    }

    public void deleteSwitch() {
        String thisSwitch=selectedSwitch;
        StringTokenizer st = new StringTokenizer(thisSwitch);
        thisSwitch=st.nextToken();
	if(parser.instantiateParser(xmlFile)) {
           parser.deleteSwitch(application,ApplHost,thisSwitch);
           parser.SaveAsXml(xmlFile);
	}
        showDetails();
    }

    public void deleteArgument() {
        String thisArgument=selectedArgument;
        StringTokenizer st = new StringTokenizer(thisArgument);
        thisArgument=st.nextToken();
	if(parser.instantiateParser(xmlFile)) {
           parser.deleteArgument(application,ApplHost,thisArgument);
           parser.SaveAsXml(xmlFile);
	}
        showDetails();
    }

    public void deleteInput() {
	if(parser.instantiateParser(xmlFile)) {
           parser.deleteInFile(application,ApplHost,selectedInput);
           parser.SaveAsXml(xmlFile);
	}
        showDetails();
    }

    public void deleteOutput() {
	if(parser.instantiateParser(xmlFile)) {
           parser.deleteOutFile(application,ApplHost,selectedOutput);
           parser.SaveAsXml(xmlFile);
	}
        showDetails();
    }

    public void acceptSwitch() {
      saveSwitch();
      showDetails();
    }

    public void acceptArgument() {
      saveArgument();
      showDetails();
    }

    public void acceptInput() {
      if(oldInFile.equals("new")) saveInput();
      else replaceInput(); 
      showDetails();
    }

    public void acceptOutput() {
      if(oldOutFile.equals("new")) saveOutput();
      else replaceOutput();
      showDetails();
    }

    public void saveSwitch() {
      System.out.println(application);
      System.out.println(ApplHost);
      System.out.println(newSwitch_nameTF.getText());
      newSwitch_ms = (String)cbs_ms.getSelectedItem();
       if(newSwitch_ms.equals("optional")) newSwitch_ms="question"; 
      System.out.println(newSwitch_ms);
      newSwitch_separator = (String)cbs_separator.getSelectedItem();
       if(newSwitch_separator.equals("-switchValue")) 
                          newSwitch_separator="none";
       if(newSwitch_separator.equals("-switch Value")) 
                          newSwitch_separator="space";
       if(newSwitch_separator.equals("-switch=Value")) 
                          newSwitch_separator="equals";
      System.out.println(newSwitch_separator);
      newSwitch_type = (String)cbs_type.getSelectedItem();
      newSwitch_m = (String)cbs_m.getSelectedItem();
       if(newSwitch_m.indexOf("fixed")>-1) newSwitch_m = "fixed";
       if(newSwitch_m.indexOf("?")>-1) newSwitch_m = "question";
       if(newSwitch_m.indexOf("+")>-1) newSwitch_m = "plus";
       if(newSwitch_m.indexOf("*")>-1) newSwitch_m = "mstar";
      System.out.println(newSwitch_m); 
      if(parser.instantiateParser(xmlFile)) {
        parser.addSwitch(application,ApplHost,newSwitch_nameTF.getText(),
          newSwitch_ms,newSwitch_separator,newSwitch_valueTF.getText(),
          newSwitch_type,newSwitch_m);
        parser.SaveAsXml(xmlFile);  
      }
    }  

    public void saveArgument() {
      newArgument_type = (String)cba_type.getSelectedItem();
      newArgument_m = (String)cba_m.getSelectedItem();
       if(newArgument_m.indexOf("fixed")>-1) newArgument_m = "fixed";
       if(newArgument_m.indexOf("?")>-1) newArgument_m = "question";
       if(newArgument_m.indexOf("+")>-1) newArgument_m = "plus";
       if(newArgument_m.indexOf("*")>-1) newArgument_m = "mstar";
      System.out.println(newArgument_m); 
      if(parser.instantiateParser(xmlFile)) {
        parser.addArgument(application,ApplHost,newArgument_nameTF.getText(),
          newArgument_type,newArgument_m);
        parser.SaveAsXml(xmlFile);  
      }
    }

    public void saveInput() {
      if(parser.instantiateParser(xmlFile)) {
        parser.addInFile(application,ApplHost,newInput_pathTF.getText(),
         newInput_nameTF.getText());
        parser.SaveAsXml(xmlFile);  
      }
    }

    public void replaceInput() {
      if(parser.instantiateParser(xmlFile)) {
        parser.replaceInFile(application,ApplHost,newInput_pathTF.getText(),
         newInput_nameTF.getText(),oldInFile);
        parser.SaveAsXml(xmlFile);  
      }
    }

    public void saveOutput() {
      if(parser.instantiateParser(xmlFile)) {
        parser.addOutFile(application,ApplHost,newOutput_pathTF.getText(),
         newOutput_nameTF.getText());
        parser.SaveAsXml(xmlFile);  
      }
    }

    public void replaceOutput() {
      if(parser.instantiateParser(xmlFile)) {
        parser.replaceOutFile(application,ApplHost,newOutput_pathTF.getText(),
         newOutput_nameTF.getText(),oldOutFile);
        parser.SaveAsXml(xmlFile);  
      }
    }

  public void showNewInputFilePanel() {
     newInputLabelA.setText("application: "+application); 
     newInputLabelH.setText("host: "+ApplHost);  
     if(parser.instantiateParser(xmlFile)) {  
     commandLine=parser.getExec(application,ApplHost);
     }
     else commandLine="none";
     newInputLabelC.setText("executable: "+commandLine);
     newInput_pathTF.setText("");
     newInput_nameTF.setText("");
     oldInFile="new";
     showCard("newInput");
  }

   public void showNewOutputFilePanel() {
     newOutputLabelA.setText("application: "+application); 
     newOutputLabelH.setText("host: "+ApplHost);  
     if(parser.instantiateParser(xmlFile)) {  
     commandLine=parser.getExec(application,ApplHost);
     }
     else commandLine="none";
     newOutputLabelC.setText("executable: "+commandLine);
     newOutput_pathTF.setText("");
     newOutput_nameTF.setText("");
     oldOutFile="new";

     showCard("newOutput");

  }
  public void showEditInputFilePanel() {
     newInputLabelA.setText("application: "+application); 
     newInputLabelH.setText("host: "+ApplHost);  
     if(parser.instantiateParser(xmlFile)) {  
     commandLine=parser.getExec(application,ApplHost);
     newInputLabelC.setText("executable: "+commandLine); 
     }
     String thisInput = (String)infiles.elementAt(currentIndex);
     System.out.println(thisInput);
     oldInFile=thisInput;
     newInput_pathTF.setText("");
     newInput_nameTF.setText(thisInput);
     showCard("newInput");
  }

  public void showEditOutputFilePanel() {
     newOutputLabelA.setText("application: "+application); 
     newOutputLabelH.setText("host: "+ApplHost);  
     if(parser.instantiateParser(xmlFile)) {  
     commandLine=parser.getExec(application,ApplHost);
     newOutputLabelC.setText("executable: "+commandLine); 
     }
     String thisOutput = (String)outfiles.elementAt(currentIndex);
     System.out.println(thisOutput);
     oldOutFile=thisOutput;
     newOutput_nameTF.setText(thisOutput);
     showCard("newOutput");
  }

    public void deleteInstallation(){
	if(parser.instantiateParser(xmlFile)) {
          parser.deleteInstalledHost(application,ApplHost);
          parser.SaveAsXml(xmlFile);
	}
        listHosts();
    }

  public void setCommand(){
System.out.println("setCommand");
   commandLine = CommandTF.getText();
System.out.println("gotText: "+commandLine);
   int idx = commandLine.lastIndexOf("/");
System.out.println("idx value = "+idx);
   String exec="";
   String path="";
   if(idx>-1) {
    path=commandLine.substring(0,idx+1);
    exec=commandLine.substring(idx+1);
   }
   else {
    exec=commandLine;
   } 
System.out.println(path+".."+exec);
   if(parser.instantiateParser(xmlFile)) {
       parser.addCommand(application,ApplHost,path,exec);
       parser.SaveAsXml(xmlFile);
   }
   else {System.out.println("Cannot add new command");}
 
  }

  public void setSwitch_m(String m) {
        newSwitch_m = m ;
  }

  public void setArgument_m(String m) {
        newArgument_m = m ;
  }
  
  public void setSwitch_type(String t) {
        newSwitch_type = t;
  } 

  public void setArgument_type(String t) {
        newArgument_type = t;
  } 

  public void setSwitch_separator(String separator) {
        newSwitch_separator = separator;
  }

  public void setSwitch_ms(String ms) {
        newSwitch_ms = ms;
  } 

  public void initializeNewSwitchCard() {
  newSwitch.setLayout(new BorderLayout());

  JPanel newSwitchNamePanel = new JPanel();
  newSwitchNamePanel.setLayout(new GridLayout(4,1));
  newSwitchNamePanel.add(new JLabel("set command switch",JLabel.CENTER));
  newSwitchLabelA = new JLabel("application name"); 
  newSwitchNamePanel.add(newSwitchLabelA);
  newSwitchLabelH = new JLabel("host name:");
  newSwitchNamePanel.add(newSwitchLabelH);
  newSwitchLabelC = new JLabel("executable:");
  newSwitchNamePanel.add(newSwitchLabelC);
  newSwitch.add(newSwitchNamePanel,BorderLayout.NORTH);

  JPanel newSwitchParamPanel = new JPanel();
  newSwitchParamPanel.setLayout(new GridLayout(6,1));
  JLabel newSwitchl1 = new JLabel(" switch name : ");
  JLabel newSwitchl2 = new JLabel("     optional? ");
  JLabel newSwitchl3 = new JLabel("   separator : ");
  JLabel newSwitchl4 = new JLabel("       value : ");
  JLabel newSwitchl5 = new JLabel("  value type : ");
  JLabel newSwitchl6 = new JLabel("multiplicity : ");
  Font myFont = new Font("Courier", Font.BOLD, 12);
  newSwitchl1.setFont(myFont);
  newSwitchl2.setFont(myFont);
  newSwitchl3.setFont(myFont);
  newSwitchl4.setFont(myFont);
  newSwitchl5.setFont(myFont);
  newSwitchl6.setFont(myFont);
  newSwitchl1.setForeground(Color.black);
  newSwitchl2.setForeground(Color.black);
  newSwitchl3.setForeground(Color.black);
  newSwitchl4.setForeground(Color.black);
  newSwitchl5.setForeground(Color.black);
  newSwitchl6.setForeground(Color.black);

  newSwitch_nameTF = new JTextField(20);
  cbs_ms = new JComboBox();
    cbs_ms.addItem("fixed");
    cbs_ms.addItem("optional");
    cbs_ms.setSelectedItem("fixed");
    cbs_ms.addItemListener(new ItemListener() {
      public void itemStateChanged(ItemEvent e) {
        setSwitch_ms((String)e.getItem());
      }
    });

  cbs_separator = new JComboBox();
    cbs_separator.addItem("-switchValue");
    cbs_separator.addItem("-switch Value");
    cbs_separator.addItem("-switch=Value");
    cbs_separator.setSelectedItem("-switch Value");
    cbs_separator.addItemListener(new ItemListener() {
      public void itemStateChanged(ItemEvent e) {
        String separator = ""; 
        String what = (String)e.getItem();
        if(what.length()>8) { 
          String selecteditem= what.substring(7,8);
          if(selecteditem.equals("V")) separator="none";
          if(selecteditem.equals(" ")) separator="space";
          if(selecteditem.equals("=")) separator="equals";
          setSwitch_separator(separator);
	}
        else {System.out.println("selected switch_ms is: "+what);} 
      }
    });

  newSwitch_valueTF = new JTextField(20);

  cbs_type = new JComboBox();
    cbs_type.addItem("literal");
    cbs_type.addItem("name");
    cbs_type.setSelectedItem("literal");
    cbs_type.addItemListener(new ItemListener() {
      public void itemStateChanged(ItemEvent e) {
        setSwitch_type((String)e.getItem());
      }
    });


  cbs_m = new JComboBox();
    cbs_m.addItem("fixed  (1)");
    cbs_m.addItem("?      (0 or 1)");
    cbs_m.addItem("+      (1 or more)");
    cbs_m.addItem("*      (0 or more)");
    cbs_m.setSelectedItem("fixed");
    cbs_m.addItemListener(new ItemListener() {
      public void itemStateChanged(ItemEvent e) {
        String m = "";
        String selecteditem = ((String)e.getItem()).substring(0,1);
        if(selecteditem.equals("f")) m="fixed";
        if(selecteditem.equals("?")) m="question";
        if(selecteditem.equals("+")) m="plus";
        if(selecteditem.equals("*")) m="star";
        setSwitch_m(m);
      }
    });

  JPanel newSwitch1 = new JPanel();
  newSwitch1.setLayout(new BorderLayout());
  newSwitch1.add(newSwitchl1,BorderLayout.WEST);
  newSwitch1.add(newSwitch_nameTF,BorderLayout.CENTER);
  newSwitchParamPanel.add(newSwitch1);  

  JPanel newSwitch2 = new JPanel();
  newSwitch2.setLayout(new BorderLayout());
  newSwitch2.add(newSwitchl2,BorderLayout.WEST);
  newSwitch2.add(cbs_ms,BorderLayout.CENTER);
  newSwitchParamPanel.add(newSwitch2);  

  JPanel newSwitch3 = new JPanel();
  newSwitch3.setLayout(new BorderLayout());
  newSwitch3.add(newSwitchl3,BorderLayout.WEST);
  newSwitch3.add(cbs_separator,BorderLayout.CENTER);
  newSwitchParamPanel.add(newSwitch3);  

  JPanel newSwitch4 = new JPanel();
  newSwitch4.setLayout(new BorderLayout());
  newSwitch4.add(newSwitchl4,BorderLayout.WEST);
  newSwitch4.add(newSwitch_valueTF,BorderLayout.CENTER);
  newSwitchParamPanel.add(newSwitch4);  

  JPanel newSwitch5 = new JPanel();
  newSwitch5.setLayout(new BorderLayout());
  newSwitch5.add(newSwitchl5,BorderLayout.WEST);
  newSwitch5.add(cbs_type,BorderLayout.CENTER);
  newSwitchParamPanel.add(newSwitch5);  

  JPanel newSwitch6 = new JPanel();
  newSwitch6.setLayout(new BorderLayout());
  newSwitch6.add(newSwitchl6,BorderLayout.WEST);
  newSwitch6.add(cbs_m,BorderLayout.CENTER);
  newSwitchParamPanel.add(newSwitch6);  

  newSwitch.add(newSwitchParamPanel, BorderLayout.CENTER);

  JPanel newSwitchButtons = new JPanel();
  newSwitchButtons.setLayout(new GridLayout(2,4));

  JButton newSwitchb1=new JButton("Next Switch"); 
  JButton newSwitchb2=new JButton("Add New Switch"); 
  JButton newSwitchb3=new JButton("Accept Switch"); 
  JButton newSwitchb4=new JButton("List Applications"); 
  JButton newSwitchb5=new JButton("Reset Switch"); 
  JButton newSwitchb6=new JButton("Delete Switch"); 
  JButton newSwitchb7=new JButton("Cancel"); 
  JButton newSwitchb8=new JButton("List Hosts"); 

  newSwitchb1.addActionListener(blistener);
  newSwitchb2.addActionListener(blistener);
  newSwitchb3.addActionListener(blistener);
  newSwitchb4.addActionListener(blistener);
  newSwitchb5.addActionListener(blistener);
  newSwitchb6.addActionListener(blistener);
  newSwitchb7.addActionListener(blistener);
  newSwitchb8.addActionListener(blistener);

  newSwitchButtons.add(newSwitchb1);
  newSwitchButtons.add(newSwitchb2);
  newSwitchButtons.add(newSwitchb3);
  newSwitchButtons.add(newSwitchb4);
  newSwitchButtons.add(newSwitchb5);
  newSwitchButtons.add(newSwitchb6);
  newSwitchButtons.add(newSwitchb7);
  newSwitchButtons.add(newSwitchb8);

  newSwitch.add(newSwitchButtons,BorderLayout.SOUTH);
  }

  public void initializeNewArgumentCard() {
  newArgument.setLayout(new BorderLayout());

  JPanel newArgumentNamePanel = new JPanel();
  newArgumentNamePanel.setLayout(new GridLayout(4,1));
  newArgumentNamePanel.add(new JLabel("set command argument",JLabel.CENTER));
  newArgumentLabelA = new JLabel("application name"); 
  newArgumentNamePanel.add(newArgumentLabelA);
  newArgumentLabelH = new JLabel("host name:");
  newArgumentNamePanel.add(newArgumentLabelH);
  newArgumentLabelC = new JLabel("executable:");
  newArgumentNamePanel.add(newArgumentLabelC);
  newArgument.add(newArgumentNamePanel,BorderLayout.NORTH);

  JPanel newArgumentParamPanel = new JPanel();
  newArgumentParamPanel.setLayout(new GridLayout(3,1));
  JLabel newArgumentl1 = new JLabel(" Argument name : ");
  JLabel newArgumentl2 = new JLabel(" Argument type : ");
  JLabel newArgumentl3 = new JLabel("  multiplicity : ");
  Font myFont = new Font("Courier", Font.BOLD, 12);
  newArgumentl1.setFont(myFont);
  newArgumentl2.setFont(myFont);
  newArgumentl3.setFont(myFont);
  newArgumentl1.setForeground(Color.black);
  newArgumentl2.setForeground(Color.black);
  newArgumentl3.setForeground(Color.black);

  newArgument_nameTF = new JTextField(20);

  cba_type = new JComboBox();
    cba_type.addItem("literal");
    cba_type.addItem("name");
    cba_type.setSelectedItem("literal");
    cba_type.addItemListener(new ItemListener() {
      public void itemStateChanged(ItemEvent e) {
        setArgument_type((String)e.getItem());
      }
    });


  cba_m = new JComboBox();
    cba_m.addItem("fixed  (1)");
    cba_m.addItem("?      (0 or 1)");
    cba_m.addItem("+      (1 or more)");
    cba_m.addItem("*      (0 or more)");
    cba_m.setSelectedItem("fixed");
    cba_m.addItemListener(new ItemListener() {
      public void itemStateChanged(ItemEvent e) {
        String m = "";
        String selecteditem = ((String)e.getItem()).substring(0,1);
        if(selecteditem.equals("f")) m="fixed";
        if(selecteditem.equals("?")) m="question";
        if(selecteditem.equals("+")) m="plus";
        if(selecteditem.equals("*")) m="star";
        setArgument_m(m);
      }
    });

  JPanel newArgument1 = new JPanel();
  newArgument1.setLayout(new BorderLayout());
  newArgument1.add(newArgumentl1,BorderLayout.WEST);
  newArgument1.add(newArgument_nameTF,BorderLayout.CENTER);
  newArgumentParamPanel.add(newArgument1);  

  JPanel newArgument2 = new JPanel();
  newArgument2.setLayout(new BorderLayout());
  newArgument2.add(newArgumentl2,BorderLayout.WEST);
  newArgument2.add(cba_type,BorderLayout.CENTER);
  newArgumentParamPanel.add(newArgument2);  

  JPanel newArgument3 = new JPanel();
  newArgument3.setLayout(new BorderLayout());
  newArgument3.add(newArgumentl3,BorderLayout.WEST);
  newArgument3.add(cba_m,BorderLayout.CENTER);
  newArgumentParamPanel.add(newArgument3);  

  newArgument.add(newArgumentParamPanel, BorderLayout.CENTER);

  JPanel newArgumentButtons = new JPanel();
  newArgumentButtons.setLayout(new GridLayout(2,4));

  JButton newArgumentb1=new JButton("Next Argument"); 
  JButton newArgumentb2=new JButton("Add New Argument"); 
  JButton newArgumentb3=new JButton("Accept Argument"); 
  JButton newArgumentb4=new JButton("List Applications"); 
  JButton newArgumentb5=new JButton("Reset Argument"); 
  JButton newArgumentb6=new JButton("Delete Argument"); 
  JButton newArgumentb7=new JButton("Cancel"); 
  JButton newArgumentb8=new JButton("List Hosts"); 

  newArgumentb1.addActionListener(blistener);
  newArgumentb2.addActionListener(blistener);
  newArgumentb3.addActionListener(blistener);
  newArgumentb4.addActionListener(blistener);
  newArgumentb5.addActionListener(blistener);
  newArgumentb6.addActionListener(blistener);
  newArgumentb7.addActionListener(blistener);
  newArgumentb8.addActionListener(blistener);

  newArgumentButtons.add(newArgumentb1);
  newArgumentButtons.add(newArgumentb2);
  newArgumentButtons.add(newArgumentb3);
  newArgumentButtons.add(newArgumentb4);
  newArgumentButtons.add(newArgumentb5);
  newArgumentButtons.add(newArgumentb6);
  newArgumentButtons.add(newArgumentb7);
  newArgumentButtons.add(newArgumentb8);

  newArgument.add(newArgumentButtons,BorderLayout.SOUTH);
  }

  public void initializeNewInputCard() {
  newInput.setLayout(new BorderLayout());

  JPanel newInputNamePanel = new JPanel();
  newInputNamePanel.setLayout(new GridLayout(4,1));
  newInputNamePanel.add(new JLabel("define input files",JLabel.CENTER));
  newInputLabelA = new JLabel("application name"); 
  newInputNamePanel.add(newInputLabelA);
  newInputLabelH = new JLabel("host name:");
  newInputNamePanel.add(newInputLabelH);
  newInputLabelC = new JLabel("executable:");
  newInputNamePanel.add(newInputLabelC);
  newInput.add(newInputNamePanel,BorderLayout.NORTH);

  JPanel newInputParamPanel = new JPanel();
  newInputParamPanel.setLayout(new GridLayout(2,1));
  JLabel newInputl1 = new JLabel(" file path : ");
  JLabel newInputl2 = new JLabel(" file name : ");
  Font myFont = new Font("Courier", Font.BOLD, 12);
  newInputl1.setFont(myFont);
  newInputl2.setFont(myFont);
  newInputl1.setForeground(Color.black);
  newInputl2.setForeground(Color.black);

  newInput_pathTF = new JTextField(20);
  newInput_nameTF = new JTextField(20);

  JPanel newInput1 = new JPanel();
  newInput1.setLayout(new BorderLayout());
  newInput1.add(newInputl1,BorderLayout.WEST);
  newInput1.add(newInput_pathTF,BorderLayout.CENTER);
  newInputParamPanel.add(newInput1);  

  JPanel newInput2 = new JPanel();
  newInput2.setLayout(new BorderLayout());
  newInput2.add(newInputl2,BorderLayout.WEST);
  newInput2.add(newInput_nameTF,BorderLayout.CENTER);
  newInputParamPanel.add(newInput2);  


  newInput.add(newInputParamPanel, BorderLayout.CENTER);

  JPanel newInputButtons = new JPanel();
  newInputButtons.setLayout(new GridLayout(2,4));

  JButton newInputb1=new JButton("Next Input"); 
  JButton newInputb2=new JButton("Add New Input"); 
  JButton newInputb3=new JButton("Accept Input"); 
  JButton newInputb4=new JButton("List Applications"); 
  JButton newInputb5=new JButton("Reset Input"); 
  JButton newInputb6=new JButton("Delete Input"); 
  JButton newInputb7=new JButton("Cancel"); 
  JButton newInputb8=new JButton("List Hosts"); 

  newInputb1.addActionListener(blistener);
  newInputb2.addActionListener(blistener);
  newInputb3.addActionListener(blistener);
  newInputb4.addActionListener(blistener);
  newInputb5.addActionListener(blistener);
  newInputb6.addActionListener(blistener);
  newInputb7.addActionListener(blistener);
  newInputb8.addActionListener(blistener);

  newInputButtons.add(newInputb1);
  newInputButtons.add(newInputb2);
  newInputButtons.add(newInputb3);
  newInputButtons.add(newInputb4);
  newInputButtons.add(newInputb5);
  newInputButtons.add(newInputb6);
  newInputButtons.add(newInputb7);
  newInputButtons.add(newInputb8);

  newInput.add(newInputButtons,BorderLayout.SOUTH);
  }

  public void initializeNewOutputCard() {
  newOutput.setLayout(new BorderLayout());

  JPanel newOutputNamePanel = new JPanel();
  newOutputNamePanel.setLayout(new GridLayout(4,1));
  newOutputNamePanel.add(new JLabel("define output files",JLabel.CENTER));
  newOutputLabelA = new JLabel("application name"); 
  newOutputNamePanel.add(newOutputLabelA);
  newOutputLabelH = new JLabel("host name:");
  newOutputNamePanel.add(newOutputLabelH);
  newOutputLabelC = new JLabel("executable:");
  newOutputNamePanel.add(newOutputLabelC);
  newOutput.add(newOutputNamePanel,BorderLayout.NORTH);

  JPanel newOutputParamPanel = new JPanel();
  newOutputParamPanel.setLayout(new GridLayout(2,1));
  JLabel newOutputl1 = new JLabel(" file path : ");
  JLabel newOutputl2 = new JLabel(" file name : ");
  Font myFont = new Font("Courier", Font.BOLD, 12);
  newOutputl1.setFont(myFont);
  newOutputl2.setFont(myFont);
  newOutputl1.setForeground(Color.black);
  newOutputl2.setForeground(Color.black);

  newOutput_pathTF = new JTextField(20);
  newOutput_nameTF = new JTextField(20);

  JPanel newOutput1 = new JPanel();
  newOutput1.setLayout(new BorderLayout());
  newOutput1.add(newOutputl1,BorderLayout.WEST);
  newOutput1.add(newOutput_pathTF,BorderLayout.CENTER);
  newOutputParamPanel.add(newOutput1);  

  JPanel newOutput2 = new JPanel();
  newOutput2.setLayout(new BorderLayout());
  newOutput2.add(newOutputl2,BorderLayout.WEST);
  newOutput2.add(newOutput_nameTF,BorderLayout.CENTER);
  newOutputParamPanel.add(newOutput2);  


  newOutput.add(newOutputParamPanel, BorderLayout.CENTER);

  JPanel newOutputButtons = new JPanel();
  newOutputButtons.setLayout(new GridLayout(2,4));

  JButton newOutputb1=new JButton("Next Output"); 
  JButton newOutputb2=new JButton("Add New Output"); 
  JButton newOutputb3=new JButton("Accept Output"); 
  JButton newOutputb4=new JButton("List Applications"); 
  JButton newOutputb5=new JButton("Reset Output"); 
  JButton newOutputb6=new JButton("Delete Output"); 
  JButton newOutputb7=new JButton("Cancel"); 
  JButton newOutputb8=new JButton("List Hosts"); 

  newOutputb1.addActionListener(blistener);
  newOutputb2.addActionListener(blistener);
  newOutputb3.addActionListener(blistener);
  newOutputb4.addActionListener(blistener);
  newOutputb5.addActionListener(blistener);
  newOutputb6.addActionListener(blistener);
  newOutputb7.addActionListener(blistener);
  newOutputb8.addActionListener(blistener);

  newOutputButtons.add(newOutputb1);
  newOutputButtons.add(newOutputb2);
  newOutputButtons.add(newOutputb3);
  newOutputButtons.add(newOutputb4);
  newOutputButtons.add(newOutputb5);
  newOutputButtons.add(newOutputb6);
  newOutputButtons.add(newOutputb7);
  newOutputButtons.add(newOutputb8);

  newOutput.add(newOutputButtons,BorderLayout.SOUTH);
  }

}



