import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;

public class LoadModule extends JInternalFrame {

 String selectedServer;
 desktop d;
 JProgressBar progressBar;
 JTextField ta,ta1;
 String currentPackage;
 String bname;
 int nPackages;
 String[] packageName; 
 String[] packagePath;
 JPanel[] packagePanel;

  public LoadModule(desktop d) {
  super("Module Administrator", true, true, true, true);
  this.d = d;
  
  this.selectedServer = d.selectedServer;

  JPanel bck = new JPanel();
  getContentPane().add(bck);

  bck.setLayout(new BorderLayout());
  JPanel titlePanel = new JPanel();
  titlePanel.setLayout(new GridLayout(4,1));
  titlePanel.add(new JLabel(" "));
  titlePanel.add(new JLabel("update packages", JLabel.CENTER));
  titlePanel.add(new JLabel(d.selectedServer, JLabel.CENTER));
  titlePanel.add(new JLabel(" "));
  bck.add(titlePanel,BorderLayout.NORTH);

     progressBar = new JProgressBar(0, 100);
     progressBar.setValue(0);
     progressBar.setStringPainted(true);

     /* messages */
     ta = new JTextField(20); 
     ta.setEditable(false);

     /* class names */
     ta1 = new JTextField(20); 
     ta1.setEditable(false);

     JTabbedPane tp = new JTabbedPane();

     JButton[] but;
     int maxBut = 30;
     but = new JButton[maxBut];
     nPackages=9;  // 0 is all!
     int iBut=0;
 
     packagePanel = new JPanel[nPackages];
     packageName = new String[nPackages];
     packagePath = new String[nPackages];

     packageName[0]="All";
     packageName[1]="Core Webflow";
     packageName[2]="ContextData";
     packageName[3]="submitJob";
     packageName[4]="File Browser";
     packageName[5]="Remote File";
     packageName[6]="AAD";
     packageName[7]="ATD";
     packageName[8]="ADCIRC";

     packagePath[0]="All";
     packagePath[1]="WebFlow:WebFlow.event";
     packagePath[2]="WebFlow.hashtable";
     packagePath[3]="WebFlow.submitJob";
     packagePath[4]="WebFlow.FB";
     packagePath[5]="WebFlow.RemoteFile:WebFlow.RemoteFile.RemoteFilePackage";
     packagePath[6]="WebFlow.xml";
     packagePath[7]="WebFlow.ATD";
     packagePath[8]="WebFlow.MSU";

     ActionListener bListener = new ActionListener() {
            public void actionPerformed(ActionEvent e) {
            String what=e.getActionCommand();
            what=what.substring(what.lastIndexOf(" ")+1);
            downloadClasses(what);
           }
     };

     ActionListener bAllListener = new ActionListener() {
            public void actionPerformed(ActionEvent e) {
            downloadAllClasses();
	    }
     };

     packagePanel[0] = new JPanel();
     but[iBut]=new JButton("update all packages");  
     but[iBut].addActionListener(bAllListener);
     packagePanel[0].add(but[iBut]);
     iBut++;   
     tp.addTab(packageName[0],packagePanel[0]); 

     for(int i=1;i<nPackages;i++){
       packagePanel[i] = new JPanel();
       StringTokenizer st = new StringTokenizer(packagePath[i],":");
       int subpackages = st.countTokens(); 
       packagePanel[i].setLayout(new GridLayout(subpackages,1));
       for(int j=0;j<subpackages;j++) {
           bname = st.nextToken();
           if(iBut==maxBut) {
	       System.out.println("but array too small: "+maxBut);
               System.exit(0);
	   }
           but[iBut] = new JButton("update package "+bname);
           setCurrentPackage(bname);
           System.out.println("bname: "+bname); 
           but[iBut].addActionListener(bListener);
          packagePanel[i].add(but[iBut]);
          iBut++;
       }
     tp.addTab(packageName[i],packagePanel[i]); 
     }

  bck.add(tp, BorderLayout.CENTER);

  JPanel pb = new JPanel();
  pb.setLayout(new GridLayout(3,1));
  pb.add(progressBar);
  pb.add(ta);
  pb.add(ta1);
  
  bck.add(pb, BorderLayout.SOUTH);
  }

  public void downloadAllClasses() {
     for(int i=1;i<nPackages;i++){
       StringTokenizer st = new StringTokenizer(packagePath[i],":");
       int subpackages = st.countTokens(); 
       for(int j=0;j<subpackages;j++) {
            bname = st.nextToken();
	    // setCurrentPackage(bname);
            downloadClasses(bname);
            }
     }
  }


  public void downloadClasses(String s){
      //   String s=currentPackage;
   System.out.println(d.WS_classes);
   updatePackages up = new updatePackages(d.WS_host,
                       "http://"+d.WS_host+":"+d.WS_port, d.WS_classes, this);
   Thread t = new Thread(up);
   up.setPackageName(s);
   System.out.println("s = "+s);
   t.start();
  }

  public void runSimpleClient() {
     CORBAclient client = new CORBAclient(d.IORfileURL);
     client.simpleClient();
  }

  public void runClient(String[] modules) {
     CORBAclient client = new CORBAclient(d.IORfileURL);
     client.Client(modules);
  }

  public void runCRPC() {
     CORBAclient client = new CORBAclient(d.IORfileURL);
     client.ClientCRPC("/npac/home/webflow/WEBFLOW/BeanContext_2.2.2/GatewayTest/Parssim.xml");
  }

  public  void setPBmaximum(int n){
    progressBar.setMaximum(n);
  }

  public  void setPBvalue(int n){
    progressBar.setValue(n);
  }
   
  public  void setClassName(String s) {
     ta1.setText(s);
  }

  public  void setPackageName(String s) {
     ta.setText(s);
  }

    public void setCurrentPackage(String s) {
     currentPackage=s;
     System.out.println("currentPackage = "+currentPackage);
    }

  public void showFileBrowser() {
      /*  FileBrowserCtr fbc = new FileBrowserCtr("/tmp", d.fb, );
          fbc.setBounds(0,0,300,500);
           d.desk.add(fbc, new Integer(0));
      */
  }
} 




